<?php
/**
 * @version    1.0.2
 * @package    com_gadecisions
 * @author     Glenn Arkell <glenn@glennarkell.com.au>
 * @copyright  2023 Glenn Arkell
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */
// no direct access
defined('_JEXEC') or die;

use \Joomla\CMS\Factory;
use \Joomla\CMS\Router\Route;
use \Joomla\CMS\Language\Text;
use \Joomla\CMS\Uri\Uri;
use \Joomla\Utilities\ArrayHelper;
use \Joomla\CMS\HTML\HTMLHelper;
use \Joomla\Session\SessionInterface;
use \Joomla\CMS\Application\SiteApplication;
use \Joomla\Component\Fields\Administrator\Helper\FieldsHelper;
use \GlennArkell\Component\Gadecisions\Administrator\Helper\GadecisionsHelper;

//Load admin language file
$lang = Factory::getLanguage();
$lang->load('com_gadecisions', JPATH_ADMINISTRATOR);

$app = Factory::getApplication();
//$menu = $app->getMenu();
//$menuID = $menu->getActive();

//if ($menuID != $app->getUserState('com_gadecisions.menu.itemId')) { }
//$app->setUserState('com_gadecisions.menu.itemId', $menuID);

// load any assets required
$wa = $this->document->getWebAssetManager()
    ->usePreset('com_gadecisions.gadecisionspreset');
GadecisionsHelper::loadTmplStyleModal($wa);

$user = GadecisionsHelper::getSpecificUser();
$cntr = 0;
$this->form->setFieldAttribute('id', 'type', 'hidden');
$this->form->setFieldAttribute('field_id', 'type', 'hidden');
$this->form->setFieldAttribute('user_id', 'type', 'hidden');
$this->form->setFieldAttribute('user_id', 'default', $user->id);
$this->form->setFieldAttribute('vote', 'label', '');

$tmplCSS = JPATH_BASE.'/media/templates/site/cassiopeia/css/template.css';
if (\file_exists($tmplCSS)) {
    $wa->registerAndUseStyle('cassiopeia', 'templates/site/cassiopeia/template.css', [], [], []);
}

//GadecisionsHelper::gaprint($menuID);

/*
$tmpl = Factory::getApplication()->getTemplate(true);
GadecisionsHelper::gaprint($menuID);
    .front-end-edit label {
        min-width: 140px !important;
    }
*/
?>
<style>
    div.controls > fieldset.votingover {
        margin-left: 15px !important;
        margin: 0 auto !important;
    }
    .btn-outline-danger {
        border: 1px solid #c52827 !important;
    }
    .btn-check:checked + .btn-outline-danger {
        color:#ffffff !important;
        background-color: #c52827 !important;
    }
    .btn-outline-success {
        border: 1px solid #457d54 !important;
    }
    .btn-check:checked + .btn-outline-success {
        color:#ffffff !important;
        background-color:#457d54 !important;
    }
    .front-end-edit .controls {
        margin-left: 5px !important;
    }
    div.control-label > label#jform_vote_lbl {
        width: 10px !important;
    }
    div.btn-group > label.btn {
        min-width: 140px !important;
    }
    button.validate.btn {
        border: 1px solid #666 !important;
    }

</style>
<div class="edit item-page front-end-edit">
<form
	id="form-motion" action="<?php echo Route::_('index.php?option=com_gadecisions&task=motionform.castVote'); ?>"
	method="post" class="form-validate form-horizontal" enctype="multipart/form-data" target="_parent">

<h3><?php echo $this->item->title; ?></h3>
    <div class="row-fluid">
        <div class="span12 form-horizontal center">

            <?php echo $this->form->renderField('id'); ?>
            <?php echo $this->form->renderField('field_id'); ?>
            <?php echo $this->form->renderField('user_id'); ?>
            <?php if ($this->item->field_id) : ?>
                <?php $fields = FieldsHelper::getFields('com_gadecisions.motionform', $this->item->field_id, true); ?>
                <?php 
                    $options = '';
                    foreach ($fields as $fld) {
                        if ($fld->id == $this->item->field_id) {
                            $opts = ArrayHelper::fromObject($fld->fieldparams->get('options'));
                            $fldParams = json_decode($fld->params);
                            //$fldclass = $fld->type == 'radio' ? 'btn btn-group' : '';
                            foreach ($opts as $opt) {
                                $options .= '<option value="'.$opt['value'].'">'.Text::_($opt['name']).'</option>';
                            }
                            $xmlFld = new SimpleXMLElement(
                                '<field name="'.$fld->name.'" type="'.$fld->type.'" class="'.$fldParams->class.'" label="" description="" >'.$options.'</field>'
                            );
                            $this->form->setField($xmlFld,'custfldmotions',true,'custflds');
                        }
                    }
                ?>
                <?php echo $this->form->renderFieldset('custflds'); ?>
            <?php else: ?>
                <?php echo $this->form->renderFieldset('voting'); ?>
            <?php endif; ?>

        </div>

        <p class="center">
            <button type="submit" class="validate btn btn-primary"><?php echo Text::_('JSUBMIT'); ?></button>
        </p>
    </div>
    <div>
        <input type="hidden" name="task" value="motionform.castVote" />
        <?php echo HTMLHelper::_('form.token'); ?>
    </div>
</form>
</div>
